/*
Si vuole scrivere un programma C per la gestione delle informazioni relative a un servizio di car
sharing.
Le persone che intendono utilizzare tale servizio devono essere registrate. Per la registrazione
devono essere inserite i seguenti dati: codice fiscale, citt, sesso e fascia di et 
( 0= <26 anni, 1= 26<= et < 45, 2= 46<= et < 45, 3= altri).
Le registrazioni delle persone  realizzata attraverso una tabella allocata dinamicamente avente 4
righe, una per ogni fascia di et.
Al momento della prenotazione di una macchina devono essere forniti i seguenti dati: codice
fiscale, data (aaaa/mm/gg), numero di ore, categoria.
Le prenotazioni sono suddivise sulla base alla categoria e sono inserire in un vettore di 3 liste.
Scrivere un programma C che codifichi la struttura dati atta a mantenere in memoria le
informazioni e che contenga un main che richiami attraverso un men di scelta le seguenti funzioni:
1) Inserimento di una nuova registrazione
2) Ricerca di una persona ( chiedere tramite tastiera solo il codice fiscale e visualizzare citt,
sesso e fascia det).
3) Inserimento di una prenotazione.
4) Eliminazione di una prenotazione dopo averla visualizzata ( Chiedere da tastiera la
categoria).
5) Salvataggio su file delle registrazioni relative a persone di un certo sesso il cui valore  letto
da tastiera
6) Lettura da file e inserimento nella tabella delle registrazioni
Liberare la memoria allocata dinamicamente al termine dellesecuzione
Non usare variabili globali
*/


#include<stdio.h>
#include<stdlib.h>
#include <string.h> 

struct persone {
  char codfiscale[20],citta[20];
  int sesso,eta;
};
struct prenotazioni {
       char codfiscale[20],data[13];
       int categoria, ore;
       };
struct atomo {
       struct prenotazioni dato;
       struct atomo *next;
       };
void elimina_prenotazioni (struct atomo *L[3]); 
void ins_prenotazioni (struct atomo *L[3]);     
void salva(struct persone *TB[4], int n[4]);
void carica(struct persone *TB[4], int n[4]);
void ins_persone (struct persone *TB[4], int n[4],struct persone pe);
void da_testa(struct atomo **L);
void leggi_persone(struct persone *pe);
void leggi_prenotazioni(struct  prenotazioni *pr);
void ricerca(struct persone *TB[4],int n[4]);

main()
{
       struct prenotazioni pr;
       struct atomo *L[3];
       struct persone *TB[4],pe;
       char cod[20];
       int scelta,i,n[4];
       
        for(i=0;i<4;i++)
        {
           TB[i]=NULL;
           n[i]=0;
        }
       
        for(i=0;i<3;i++)
           L[i]=NULL;
        
        do {
        
        printf("Scegli tra le seguenti opzioni\n");
        printf("1) Inserimento di una registrazione\n");
        printf("2) Ricerca di una persona\n");
        printf("3) Inserimento di una prenotazione\n");
        printf("4) Eliminazione prenotazione\n");
        printf("5) Salva\n");
        printf("6) Lettura da file e inserimento registrazioni\n");
        printf("0) Fine\n");
        scanf("%d",&scelta);
        switch(scelta){
                       case 1: leggi_persone(&pe);
                               ins_persone(TB,n,pe); 
                               break;
                       case 2: ricerca(TB,n);
                               break;
                       case 3: ins_prenotazioni(L); 
                               break;
                       case 4: elimina_prenotazioni(L);
                               break;
                       case 5: salva(TB,n) ;
                               break;
                       case 6: carica(TB,n);
                               break;
                       default:;
                       }
        }while(scelta!=0);
        
        for(i=0;i<4;i++)
           free(TB[i]);
        
        for(i=0;i<3;i++)
          while(L[i]!=NULL)
            da_testa(&L[i]); 
}

void leggi_persone(struct persone *pe){              
     printf("Codice fiscale: \n");                     
     scanf("%s",pe->codfiscale );                         
     printf("Citta': \n");                              
     scanf("%s",pe->citta);
     printf("Sesso:(0 maschio,1 femmina) \n");
     scanf("%d",&pe ->sesso);
     printf("Eta'( 0:   <26 anni 1:  26<=anni<45  2:   46<=anni<65   3:  altri :\n");
     scanf("%d",&pe->eta); 
}

  void ins_persone (struct persone *TB[4], int n[4],struct persone pe)
{
     struct persone *aux;
     int i;
     i=pe.eta;
     aux=(struct persone *) realloc(TB[i],sizeof(struct persone)*(n[i]+1));
     if (aux==NULL)
          return;
     TB[i]=aux;
     TB[i][n[i]]=pe;
     n[i]++;      
}  
   
void ricerca (struct persone *TB[4],int n[4])
{    char codfisc[20];
     int eta,j;
     
     
     printf("Codice fiscale:\n ");
     scanf("%s",codfisc);
     
     for(eta=0;eta<4;eta++)
      for(j=0;j<n[eta];j++)
        if(strcmp(codfisc,TB[eta][j].codfiscale)==0)
                {printf("Trovato\n");
                 printf("Citta': %s\n",TB[eta][j].citta);
                 printf("Sesso: %d\n",TB[eta][j].sesso);
                 printf("Fascia eta': %d\n",TB[eta][j].eta);
                 return;
                }
     /* se si arriva in questo punto l'elemento non e' stato trovato */    
     printf("Non trovato\n");
}
         

 
void leggi_prenotazioni(struct  prenotazioni *pr){              
     printf("Cod fiscale: \n");                     
     scanf("%s",pr->codfiscale );                         
     printf("Data: \n");                              
     scanf("%s",pr->data);
     printf("Categoria: \n");
     scanf("%d",&pr->categoria    );
     printf("Ore: \n");
     scanf("%d",&pr->ore);  
}

void ins_prenotazioni (struct atomo *L[3])
{
     struct prenotazioni pr;
     struct atomo *a;
     int i;
     
     a=malloc(sizeof(struct atomo));
     if(a==NULL)
        return;
     
     leggi_prenotazioni(&pr);
     
     i=pr.categoria;
     a->dato=pr;
     
     a->next=L[i];
     L[i]=a;
}

void da_testa(struct atomo **L)
{ 
  struct atomo *a;
 
  a=*L;
  *L=a->next;
  free(a); 
}

void elimina_prenotazioni (struct atomo *L[3])
{
     int i;
     char codfisc[20];
     struct atomo *l1,*l2;
     
     printf("Codice fiscale:  \n");
     scanf("%s", codfisc);
     printf("Categoria: \n ");
     scanf("%d", &i);
          
     if(L[i]==NULL)
     {
        printf("lista vuota\n");
        return;
     }
     
     if(strcmp(codfisc,L[i]->dato.codfiscale)==0)
     {
        printf("Data:  %s\n", L[i]->dato.data);
        printf("Ore: %d\n", L[i]->dato.ore);
        da_testa(&L[i]);
        return;
     }
     
     l1=L[i]->next;
     l2=L[i];
     while(l1!=NULL)
       if(strcmp(codfisc,l1->dato.codfiscale)==0)
          {
            l2->next=l1->next;
            printf("Data:  %s\n", l1->dato.data);
            printf("Ore: %d\n", l1->dato.ore);
            free(l1);
            return;
          }
          else
          {
               l2=l2->next;
               l1=l1->next;
          }
               
    printf("prenotazione non trovata\n");
   
}



void carica(struct persone *TB[4], int n[4])
{
     FILE *pf;
     struct persone pe;
     int i;
     
     pf=fopen("persone.txt", "r");
     if(pf) {
              while(fread(&pe,sizeof(struct persone),1,pf)!=0)
                                  
                  ins_persone(TB,n,pe);
                  
              fclose(pf);
              }
}

void salva(struct persone *TB[4], int n[4])
{
     FILE *pf;
     
     struct persone pe;
     int i,j,s;
     
     printf("Sesso:(0 maschio,1 femmina) \n");
     scanf("%d",&s);
     
     pf=fopen("persone.txt", "w");
     if(pf) {
              for(i=0;i<4;i++)
                for(j=0;j<n[i];j++)
                 { pe=TB[i][j];
                   if(TB[i][j].sesso==s)
                      fwrite(&pe,sizeof(struct persone),1,pf);
                 } 
              
               fclose(pf);
            }  
     } 
        

